#include "GLCD.h"
#include "utilities.h"
#include "GLCDBMP.h"
#include<stdio.h>
char displayBuffer[128*64];
int dum;
void GLCD_init(void)
{

		SET(GLCD_control_dir,GLCD_RS);//
		SET(GLCD_control_dir,GLCD_RW);
		SET(GLCD_control_dir,GLCD_EN);
		SET(GLCD_control_dir,GLCD_RST);
		SET(GLCD_control_dir,GLCD_CS1);
		SET(GLCD_control_dir,GLCD_CS2);
		_BIT_SET(GLCD_data_dir,(0xFF<<datashift));		
		
	  SET(GLCD_control_set,GLCD_RST);
		SET(GLCD_control_clr,GLCD_EN);
		
	// Select the Page0/Page1 and Turn on the GLCD 
    GLCD_SelectPage0();
    GLCD_send_command(0x3F);//LCD ON
		GLCD_send_command(0xC0);//START FROM LEFTMOST
		GLCD_send_command(0x8B);//LINE 0
		GLCD_send_command(0x40);//CURSOR 0
	
    GLCD_SelectPage1();
    GLCD_send_command(0x3F);//LCD ON
		GLCD_send_command(0xC0);//START FROM LEFTMOST
		GLCD_send_command(0x8B);//LINE 0
		GLCD_send_command(0x40);//CURSOR 0
}

void delay_us(int count)
{
  int j=0,i=0;

  for(j=0;j<count;j++)
  {
    /* At 60Mhz, the below loop introduces
    delay of APPROX 1 us */
    for(i=0;i<4;i++);
  }
}

void GLCD_busy(void)
{
	CLR(GLCD_data_dir,BUSY_bit);//SET BUSY_BIT AS INPUT
	delay_us(2);
	SET(GLCD_control_set,GLCD_RW);//SET RW FOR READ MODE
	SET(GLCD_control_clr,GLCD_RS);//CLR RS FOR COMMAND MODE
	delay_us(2);
	SET(GLCD_control_set,GLCD_EN);
	delay_us(2);
	while(CHK(GLCD_data_pin,BUSY_bit));//WAIT FOR INTERNAL OPERATION
	SET(GLCD_control_clr,GLCD_EN);
	SET(GLCD_data_dir,BUSY_bit);
}

void GLCD_send_command(unsigned char command)
{		
	 GLCD_busy();//WAIT
	 SET(GLCD_control_clr,GLCD_RS);
	 SET(GLCD_control_clr,GLCD_RW);
	 _BIT_SET(GLCD_data_clr,(0xff<<datashift));
	 _BIT_SET(GLCD_data_set,(command<<datashift));
	 delay_us(5);
	 SET(GLCD_control_set,GLCD_EN);
	 delay_us(5);
	 SET(GLCD_control_clr,GLCD_EN);
}

void GLCD_send_data(unsigned char data)
{	  
	 GLCD_busy();//WAIT
	 SET(GLCD_control_set,GLCD_RS);
	 SET(GLCD_control_clr,GLCD_RW);
	 _BIT_SET(GLCD_data_clr,(0xff<<datashift));
	 _BIT_SET(GLCD_data_set,(data<<datashift));
	 delay_us(5);
	 SET(GLCD_control_set,GLCD_EN);
	 delay_us(5);
	 SET(GLCD_control_clr,GLCD_EN);	
}

void GLCD_DisplayChar(const unsigned char *ptr_array)
{
    int i;
    for(i=0;i<8;i++) // 5x7 font, 5 chars + 1 blankspace
        GLCD_send_data(ptr_array[i]);
}


void addBufferUnit(int line,int cursor,const unsigned char *ptr_array)
{
	int index;
	
		for(index=0;index<8;++index)
	{
		displayBuffer[line*128+cursor+index]=ptr_array[index];
	}
}

void glcdDisplay()
{
	int line,cursor;
	for(line=0;line<8;++line)
	{
		GLCD_SelectPage0();
    GLCD_send_command(0x40);
		GLCD_send_command(0xB8+line);
		for(cursor=0;cursor<128;++cursor)
		{
			delay_us(10);
			GLCD_send_data(displayBuffer[128*line+cursor]);
			if(cursor==63)
			{
				GLCD_SelectPage1();
				GLCD_send_command(0x40);
				GLCD_send_command(0xB8+line);
			}
		}
	}
	for(dum=0;dum<(128*64);dum++)
				displayBuffer[dum]=0;
}




void GLCD_Clear()
{
	int line,cursor;

	for(line=0;line<8;line++)  /* loop through all the 8lines to clear the display */
	{
		GLCD_SelectPage0();   /* Select page0 and set the cursor to first position */
		 GLCD_send_command(0x40);
		 GLCD_send_command(0xB8+line);
		for(cursor=0;cursor<128;cursor++) /* Clear all the 128 pixels of selected line */
		{
			if(cursor==64)  /* Has the cursor reached end of page0 */
			{
				GLCD_SelectPage1(); /*  then set it to beginning of page1 */
				GLCD_send_command(0x40);
				 GLCD_send_command(0xB8+line);
			}
			GLCD_send_data(0x00); /* Clear each pixel by displaying blank */
		}
	}
}




void GLCD_SetCursor(int lineNumber,int CursorPosition)
{

	int pageNumber;

	if((lineNumber <= 8) && (CursorPosition <= 128))
	{
		pageNumber = CursorPosition / 64; //Divide the cursor pos by 64 to get the page
		CursorPosition = CursorPosition % 0x40; // Cusror pos should be within 64(0x3f),
		if(pageNumber==0x00)  /* Check for page number and set accordingly */
		{
			GLCD_SelectPage0();
		}
		else
		{
			GLCD_SelectPage1();
		}

	
		GLCD_send_command(lineNumber+0xB8); /* Command the LCD to move to specified page,line,cursor*/
		GLCD_send_command(CursorPosition+0x40);
	}
}


void GLCD_DisplayLogo(const unsigned char ptr_Logo[])
{
	int line,cursor;

	for(line=0;line<8;line++)
	{
		GLCD_SelectPage0();
    GLCD_send_command(0x40);
		GLCD_send_command(0xB8+line);
		for(cursor=0;cursor<128;cursor++)
		{
			if(cursor==64)
			{
				GLCD_SelectPage1();
				GLCD_send_command(0x40);
				GLCD_send_command(0xB8+line);
			}
			GLCD_send_data(*ptr_Logo++);
		}
	}
}

void GAME_init(void)
{
	GLCD_Clear();
	GLCD_DisplayLogo(f1);
	delay_us(500000);
	GLCD_Clear();
	GLCD_DisplayLogo(f2);
	delay_us(500000);
	GLCD_Clear();
	GLCD_DisplayLogo(f3);
	delay_us(500000);
	GLCD_Clear();
	GLCD_DisplayLogo(f4);
	delay_us(400000);
	GLCD_Clear();
	GLCD_DisplayLogo(f5);
	delay_us(400000);
	GLCD_Clear();
	GLCD_DisplayLogo(f6);
	delay_us(400000);
	GLCD_Clear();
	GLCD_DisplayLogo(f7);
	delay_us(400000);
	GLCD_Clear();
	GLCD_DisplayLogo(f8);
	delay_us(300000);
	GLCD_Clear();
	GLCD_DisplayLogo(f9);
	delay_us(300000);
	GLCD_Clear();
	GLCD_DisplayLogo(f10);
	delay_us(300000);
	GLCD_Clear();
	GLCD_DisplayLogo(f11);
	delay_us(300000);
	GLCD_Clear();
	GLCD_DisplayLogo(f12);
	delay_us(200000);
	GLCD_Clear();
	GLCD_DisplayLogo(f13);
	delay_us(200000);
	GLCD_Clear();
	GLCD_DisplayLogo(f14);
	delay_us(200000);
	GLCD_Clear();
	GLCD_DisplayLogo(f15);
	delay_us(500000);
	GLCD_Clear();
	GLCD_DisplayLogo(f16);
	delay_us(500000);
	GLCD_Clear();
	GLCD_DisplayLogo(f17);
	delay_us(500000);
	GLCD_Clear();	
	GLCD_DisplayLogo(f18);
		delay_us(1000000);
	GLCD_Clear();
	
}


void disp_int(int i)
{
	int dum_0=0,dum_10=0,dum_100=0,i1;
  if(i>=999)
		i=999;
	i1=i;
	dum_0=i1%10;//3
	i1=i/10;
	dum_10=i1%10;//4
	i1=i/100;
	dum_100=i1;//1
	//printf("dum_0=%d,dum_10=%d,dum_100=%d",dum_0,dum_10,dum_100);
	switch(dum_100)
			 {
				 case 0:
				    addBufferUnit(7,0,zero);
				    break;
				 case 1:
				    addBufferUnit(7,0,one);
				    break;
				 case 2:
			      addBufferUnit(7,0,two);
				    break;
				 case 3:
				    addBufferUnit(7,0,three);
				    break;
				 case 4:
				    addBufferUnit(7,0,four);
				    break;
				 case 5:
			      addBufferUnit(7,0,five);
				    break;
				 case 6:
				    addBufferUnit(7,0,six);
				    break;
				 case 7:
				    addBufferUnit(7,0,seven);
				    break;
				 case 8:
			      addBufferUnit(7,0,eight);
				    break;
				 case 9:
			      addBufferUnit(7,0,nine);
				    break;
					default:;
				}
			 
	switch(dum_10)
			 {
				 case 0:
				    addBufferUnit(6,0,zero);
				    break;
				 case 1:
				    addBufferUnit(6,0,one);
				    break;
				 case 2:
			      addBufferUnit(6,0,two);
				    break;
				 case 3:
				    addBufferUnit(6,0,three);
				    break;
				 case 4:
				    addBufferUnit(6,0,four);
				    break;
				 case 5:
			      addBufferUnit(6,0,five);
				    break;
				 case 6:
				    addBufferUnit(6,0,six);
				    break;
				 case 7:
				    addBufferUnit(6,0,seven);
				    break;
				 case 8:
			      addBufferUnit(6,0,eight);
				    break;
				 case 9:
			      addBufferUnit(6,0,nine);
				    break;
					default:;
				}

	switch(dum_0)
			 {
				 case 0:
				    addBufferUnit(5,0,zero);
				    break;
				 case 1:
				    addBufferUnit(5,0,one);
				    break;
				 case 2:
			      addBufferUnit(5,0,two);
				    break;
				 case 3:
				    addBufferUnit(5,0,three);
				    break;
				 case 4:
				    addBufferUnit(5,0,four);
				    break;
				 case 5:
			      addBufferUnit(5,0,five);
				    break;
				 case 6:
				    addBufferUnit(5,0,six);
				    break;
				 case 7:
				    addBufferUnit(5,0,seven);
				    break;
				 case 8:
			      addBufferUnit(5,0,eight);
				    break;
				 case 9:
			      addBufferUnit(5,0,nine);
				    break;
					default:;
				}				
}

void disp_int1(int i)
{
	int dum_0=0,dum_10=0,dum_100=0,i1;
//	if(i>=999)
//		i=786;
	i1=i;
	dum_0=i1%10;//3
	i1=i/10;
	dum_10=i1%10;//4
	i1=i/100;
	dum_100=i1;//1
	//printf("dum_0=%d,dum_10=%d,dum_100=%d",dum_0,dum_10,dum_100);
	switch(dum_100)
			 {
				 case 0:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(zero);
				 break;
				 case 1:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(one);
				 break;case 2:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(two);
				 break;case 3:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(three);
				 break;case 4:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(four);
				 break;case 5:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(five);
				 break;case 6:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(six);
				 break;case 7:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(seven);
				 break;case 8:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(eight);
				 break;case 9:
			      GLCD_SetCursor(5,85);
            GLCD_DisplayChar(nine);
					default:;
				}
			 
	switch(dum_10)
			 {
				 case 0:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(zero);
				 break;case 1:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(one);
				 break;case 2:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(two);
				 break;case 3:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(three);
				 break;case 4:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(four);
				 break;case 5:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(five);
				 break;case 6:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(six);
				 break;case 7:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(seven);
				 break;case 8:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(eight);
				 break;case 9:
			      GLCD_SetCursor(4,85);
            GLCD_DisplayChar(nine);
					default:;
				}

	switch(dum_0)
			 {
				 case 0:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(zero);
				 break;case 1:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(one);
				 break;case 2:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(two);
				 break;case 3:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(three);
				 break;case 4:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(four);
				 break;case 5:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(five);
				 break;case 6:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(six);
				 break;case 7:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(seven);
				 break;case 8:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(eight);
				 break;case 9:
			      GLCD_SetCursor(3,85);
            GLCD_DisplayChar(nine);
					default:;
				}				
}
